# -*- coding: utf-8 -*-
import random

import irc3
from docopt import Dict as DocOptDict
from irc3.plugins.command import command
from irc3.utils import IrcString

from . import DatabasePlugin

RAINBOW = (5, 7, 8, 9, 3, 10, 12, 2, 6, 13)
RAINBOW_LEN = len(RAINBOW)


@irc3.plugin
class Useless(DatabasePlugin):
    requires = ['irc3.plugins.command',
                'nxy.plugins.storage']
    WOAH = (
        'woah',
        'woah indeed',
        'woah woah woah!',
        'keep your woahs to yourself',
    )

    ISP_HOSTS = (
        'vodafone',
        'telefonica',
        'kabel',
        'unity-media',
    )

    @irc3.event(r'(?i)^:(?P<mask>\S+) JOIN :(?P<target>#\S+)$')
    def tehkuh(self, mask, target):
        nick = IrcString(mask).nick
        if 'TehKuh' in mask.lower() and self.ISP_HOSTS in mask.lower():
            self.bot.privmsg(target, '{}: Bouncer'.format(nick))

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<target>\S+) :.*(woah|whoa).*$')
    def woah(self, target: str):
        """Colorize words in a sentence with rainbow colors."""
        if random.randint(0, 4) is 0:
            self.bot.privmsg(target, random.choice(self.WOAH))

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<target>\S+) :(?P<msg>huehuehue)$')
    def huehuehue(self, target: str, msg: str):
        """Returns a huehuehue when someone writes it."""
        self.bot.privmsg(target, msg)

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<target>\S+) :reeeeee$')
    def reeeeee(self, target: str):
        """Returns a REEEE."""
        self.bot.privmsg(target, 'REEEEEEEEEEEEEEEEEEEEEEEEEEEE')

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<target>\S+) :same$')
    def same(self, target: str):
        """Returns a plain same when a user writes same."""
        self.bot.privmsg(target, 'same')

    @irc3.event(r'(?i)^:\S+ PRIVMSG (?P<target>\S+) :\[(?P<msg>.*)\]$')
    def intensifies(self, target: str, msg: str):
        """String with brackets around will be returned with INTENSIFIES."""
        self.bot.privmsg(target, '\x02[{msg} INTENSIFIES]'.format(
            msg=msg.upper()))

    @command
    def kill(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Kills a user with a random message.

        %%kill [<nick>]
        """
        self.cur.execute('''
        select
          item
        from
          kills
        order by
          random()
        limit
          1
        ''')
        self.bot.action(target, self.cur.fetchone()['item']
                        .format(nick=args.get('<nick>') or mask.nick))

    @command
    def yiff(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Yiffs a user with a random message.

        %%yiff [<nick>]
        """
        self.cur.execute('''
        select
          item
        from
          yiffs
        order by
          random()
        limit
          1
        ''')
        self.bot.action(target, self.cur.fetchone()['item']
                        .format(nick=args.get('<nick>') or mask.nick))

    @command
    def waifu(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Get waifu for a user.

        %%waifu [<nick>...]
        """
        nick = ' '.join(args.get('<nick>')) or mask.nick

        if nick.startswith('='):
            waifu = nick[1:]

            self.cur.execute('''
            insert into
              users (nick, waifu)
            values
              (%s, %s)
            on conflict (nick) do update set
              waifu = excluded.waifu
            ''', [mask.nick, waifu])

            self.bot.notice(mask.nick, 'Waifu set to: {waifu}'
                            .format(waifu=waifu))
        else:
            self.cur.execute('''
            select
              waifu
            from
              users
            where
              lower(nick) = lower(%s)
            ''', [nick])
            result = self.cur.fetchone()

            if result and result['waifu']:
                return '\x02[Waifu]\x0F {nick}: {waifu}'.format(
                    nick=nick,
                    waifu=result['waifu'])

    @command
    def husbando(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Get husbando for a user.

        %%husbando [<nick>...]
        """
        nick = ' '.join(args.get('<nick>')) or mask.nick

        if nick.startswith('='):
            nick = nick[1:]

            self.cur.execute('''
            insert into
              users (nick, husbando)
            values
              (%s, %s)
            on conflict (nick) do update set
              husbando = excluded.husbando
            ''', [mask.nick, nick])

            self.bot.notice(mask.nick, 'Husbando set to: {husbando}'
                            .format(husbando=nick))
        else:
            self.cur.execute('''
            select
              husbando
            from
              users
            where
              lower(nick) = lower(%s)
            ''', [nick])
            result = self.cur.fetchone()

            if result and result['husbando']:
                return '\x02[Husbando]\x0F {nick}: {husbando}'.format(
                    nick=nick,
                    husbando=result['husbando'])

    @command
    def storyofpomfface(self, mask: IrcString, target: IrcString,
                        args: DocOptDict):
        """Story of pomf face.

        %%storyofpomfface
        """
        for face in (':O C==3', ':OC==3', ':C==3', ':C=3', ':C3', ':3'):
            self.bot.privmsg(target, face)

    @command
    def choose(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Decides between items separated by comma.

        %%choose <items>...
        """
        choice = random.choice(' '.join(args['<items>']).split(','))
        return '{nick}: {choice}'.format(nick=mask.nick,
                                         choice=choice.strip())

    @command
    def jn(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Decides between yes and no (for a question).

        %%jn <question>...
        %%jn
        """
        choice = random.choice(['3Ja', '4Nein'])
        return '{nick}: \x02\x03{choice}\x0F'.format(nick=mask.nick,
                                                     choice=choice)

    @command
    def kiss(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Kisses a user.

        %%kiss <nick>
        """
        return '(づ｡◕‿‿◕｡)\x034。。・゜゜・。。・゜❤\x0F {nick} \x034❤'.format(
            nick=args['<nick>'])

    @command
    def hug(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Hugs a user.

        %%hug <nick>
        """
        return '\x034♥♡❤♡♥\x03 {nick} \x034♥♡❤♡♥'.format(nick=args['<nick>'])

    @command
    def bier(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Gives nick a beer.

        %%bier [<nick>]
        """
        self.bot.action(target, 'schenkt ein kühles Blondes an {nick} aus.'
                        .format(nick=args.get('<nick>') or mask.nick))

    @command
    def fucken(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Kills and fucks a nick.

        %%fucken [<nick>]
        """
        self.bot.action(target, 'fuckt {nick} und tötet {nick} anschließend.'
                        .format(nick=args.get('<nick>') or mask.nick))

    @command
    def anhero(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Kicks a nick.

        %%anhero
        """
        self.bot.privmsg(target, 'Sayonara bonzai-chan...')
        self.bot.kick(target, mask.nick)

    @command
    def sudoku(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Kicks a nick.

        %%sudoku
        """
        self.anhero(mask, target, args)

    @command
    def hack(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Hacks (a user).

        %%hack [<nick>]
        """
        nick = args.get('<nick>') or ''
        return 'hacking{nick}...'.format(nick=' %s' % nick if nick else '')

    @command
    def gay(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Make someone gay (alias to rainbow)

        %%gay <word>...
        """
        return self.rainbow(mask, target, args)

    @command
    def rainbow(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Colorize a word in rainbow colors.

        %%rainbow <word>...
        """
        last = 0
        word = []
        for char in ' '.join(args.get('<word>')):
            if char != ' ':
                char = self._rainbow(last, char)
                last += 1
            word.append(char)
        return ''.join(word)

    @command
    def wrainbow(self, mask: IrcString, target: IrcString, args: DocOptDict):
        """Colorize words in a sentence with rainbow colors.

        %%wrainbow <words>...
        """
        return ' '.join([self._rainbow(i, word) for i, word
                         in enumerate(args['<words>'])])

    def _rainbow(self, i, char):
        return '\x03{color}{char}'.format(color=RAINBOW[i % RAINBOW_LEN],
                                          char=char)
